
/* ##############################################################
	설  명 : [Modal]공지사항 상세/수정 팝업
	작성일 : 2023. 01. 19.
	작성자 : NTsoft
	수정일 	        수정자 	 수정내용
	-------         -------- ---------------------------
	2023. 01. 19.	NTsoft 	 최초 생성
*/
let noticeUpdateModal = {
	callback : null,
	reqParam : null,
	dataList : null,
	/* 모달 초기화 작업 */
	init : function () {
		$('#noticeUpdateModal').remove();
		$('body').append( this.HtmlTemplate);
		//그리드 이벤트
		this.setEvent();
	},
	/* 그리드 이벤트 설정 */
	setEvent:function() {
		$('#noticeUpdateModal .btnCancle').on("click", function(){
			noticeUpdateModal.close();
		});
		
		$('#noticeUpdateModal .btnSave').on("click", function(){
			noticeUpdateModal.save("I");
		});
		
		$("#noticeUpdateModal #modalOpenDate").datetimepicker({
			allowInputToggle: true,
			format: 'YYYY-MM-DD',
			defaultDate: moment()
		});
	},
	/* 데이터 선택 */
	setSelect:function(selectNumber) {
		let checkedData = dataList[selectNumber];
		if(dataList==null||checkedData==undefined){
			return ;
		}
		
		if( noticeUpdateModal.callback )  {
			noticeUpdateModal.callback(checkedData);
		}
		noticeUpdateModal.close();
	},
	// 상세 조회
	search:function(state) {
		let muNoticeId = noticeUpdateModal.reqParam.muNoticeId;
		
		if(true != fn_emptyCheck(muNoticeId)){
			modalEvent.warning("등록", "공지사항 정보가 없습니다.");	
			return;
		}
		
		let formData = new FormData();
		formData.append("menuClass", menuClass);
		formData.append("muNoticeId", muNoticeId);

		$.ajax({
			url: encodeURI('/webnotice/selectNotice.do'),
			data: formData,
			dataType: "json",
			processData: false,
			contentType: false,
			type: 'POST',
			async: true,
			success: function(data){
				if('0'==data.msgCode){
					$("#noticeUpdateModal #modalTitle").val(data.rows[0].title);
					$("#noticeUpdateModal #modalContent").val(data.rows[0].content);
					$("#noticeUpdateModal #modalOpenDate").val(data.rows[0].openDate);
					$("#noticeUpdateModal #modalOpenTime").val(data.rows[0].openTime);
				}
				else{
					modalEvent.danger("조회 오류", data.msgDesc);
				}
			},
			error : function(xhr, status, error) {
				modalEvent.danger("조회 오류", "조회 중 오류가 발생하였습니다. 잠시후 다시시도하십시오.");
			},
			beforeSend:function(){
				
			},
			complete:function(){
				
			}
		});
	},
	//저장
	save:function(state) {
		let muNoticeId = noticeUpdateModal.reqParam.muNoticeId;
		let title      = $("#noticeUpdateModal #modalTitle").val();
		let content    = $("#noticeUpdateModal #modalContent").val();
		let openDate   = $("#noticeUpdateModal #modalOpenDate").val();
		let openTime   = $("#noticeUpdateModal #modalOpenTime").val();
		
		if(true != fn_emptyCheck(title)){
			modalEvent.warning("수정", "제목 정보가 없습니다.");	
			return;
		}
		else{
			if(true != fn_lengthCheck(title, 100)) {
				modalEvent.warning("수정", "제목 정보는 100자를 넘을 수 없습니다.");	
				return;
			}
		}
		
		if(true != fn_emptyCheck(content)){
			modalEvent.warning("수정", "내용 정보가 없습니다.");	
			return;
		}
		
		if(true != fn_emptyCheck(openDate)){
			modalEvent.warning("수정", "게시일 정보가 없습니다.");	
			return;
		}
		
		if(true != fn_emptyCheck(openTime)){
			modalEvent.warning("수정", "게시시간 정보가 없습니다.");	
			return;
		}
		
		modalEvent.info("수정", "공지사항 정보를 수정하시겠습니까?", function(){
			let formData = new FormData();
			formData.append("menuClass", menuClass);
			formData.append("muNoticeId", muNoticeId);
			formData.append("title", title);
			formData.append("content", content);
			formData.append("openDate", openDate);
			formData.append("openTime", openTime);
	
			$.ajax({
				url: encodeURI('/webnotice/updateNotice.do'),
				data: formData,
				dataType: "json",
				processData: false,
				contentType: false,
				type: 'POST',
				async: true,
				success: function(data){
					if('0'==data.msgCode){
						modalEvent.success("수정 성공", data.msgDesc, function(){
							if( noticeUpdateModal.callback )  {
								noticeUpdateModal.callback();
							}
							noticeUpdateModal.close();
						});
					}
					else{
						modalEvent.danger("수정 오류", data.msgDesc);
					}
				},
				error : function(xhr, status, error) {
					modalEvent.danger("수정 오류", "등록 중 오류가 발생하였습니다. 잠시후 다시시도하십시오.");
				},
				beforeSend:function(){
					
				},
				complete:function(){
					
				}
			});
		});
	},
	/*
	 * 팝업
	 * callback : 콜백함수, reqParam: 팝업파라미터
	 */
	popup:function(callback, reqParam) {
		// 초기화 후 열기
		noticeUpdateModal.init();
		
		//콜백함수 지정.
		noticeUpdateModal.callback = callback;
		noticeUpdateModal.reqParam = reqParam;
		noticeUpdateModal.dataList = null;
		
		setTimeout(function(){
			$('#noticeUpdateModal').modal('show')
		}, 200);
		
		noticeUpdateModal.search();
	},
	/*
	 * 팝업 닫기
	 */
	close:function() {
		$('#noticeUpdateModal').modal('hide');

		setTimeout(function(){
			$('#noticeUpdateModal').remove();
		},500);
	},
	HtmlTemplate : `
	<div id="noticeUpdateModal" class="modal notice_detail_user_modal fade" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="">
		<div class="modal-dialog">
			<div class="modal-content">
				<div class="modal-header">
					<p class="title">공지사항 수정</p>
				</div>
	
				<div class="modal-body">
					<div class="form_box">
						<div class="input_box">
							<label>제목</label>
							<input type="text" id="modalTitle" placeholder="제목 입력" maxlength="100">
						</div>

						<div class="textarea_box">
							<label>내용</label>
							<textarea id="modalContent" placeholder="내용을 입력해주세요."></textarea>
						</div>

						<div class="registration_box">
							<label>게시일</label>

							<div class="date_box">
								<img src="/image/web/calendar.svg" alt="calendar"/>
								<input type="date" class="date_picker" id="modalOpenDate">
							</div>

							<input type="text" id="modalOpenTime" placeholder="00:00" maxlength="5">
						</div>
					</div>
				</div>

				<div class="modal-footer">
					<div class="btn_box">
						<button type="button" class="cancel_btn btnCancle">취소</button>
						<button type="button" class="correction_bth btnSave">수정</button>
					</div>
				</div>
			</div>
		</div>
	</div>
    `
};